﻿Type=Service
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

' TODO


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	'Dim TickCount As Int = 0
	
	Dim rv As RemoteViews
'	Dim getJob As HttpJob
	
	Private mAppWidgetIdList As List
	
	Private tSQL As SQL
	
	Private phone As PhoneEvents
	
	Private nb As NotificationBuilder
End Sub

Sub Service_Create
	rv = ConfigureHomeWidget("WidgetLayout", "Widget", 0, "Helmuts Status", True)
	mAppWidgetIdList.Initialize
	tSQL.Initialize(File.DirInternal, "widgets.db", True)
	createDB
	phone.Initialize("phoneEvent")
	nb.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)
	Log("ShowStatus.Service_Start: Starting with action <" & StartingIntent.Action & ">")

	mAppWidgetIdList.Clear
	
	' Service für ein einzelnes Widget
	If StartingIntent.HasExtra("appWidgetId") Then
		mAppWidgetIdList.Add(StartingIntent.GetExtra("appWidgetId"))
	End If

	Dim helper() As Int
	' Service für eine Liste von Widgets
	If mAppWidgetIdList.Size = 0 Then
		If StartingIntent.HasExtra("appWidgetIds") Then
			helper = StartingIntent.GetExtra("appWidgetIds")
			mAppWidgetIdList.AddAll(helper)
		End If
	End If
	
	' Manueller Aufruf ohne Widget-IDs in einem Extra
	If mAppWidgetIdList.Size = 0 Then
		helper = WidgetEx.GetWidgetIds("widgetservice")
		mAppWidgetIdList.AddAll(helper)
	End If

	' Wenn keine Widget da ist, können wir raus
	If mAppWidgetIdList.Size = 0 Then
		Log("ShowStatus.Service_Start: Keine Widgets auf dem Homescreen -> exit")
		Return
	End If

	' Nachschauen, was wir tun sollen
	If Not(rv.HandleWidgetEvents(StartingIntent)) Then
		'If the service is called from the configuration activity, the starting intent has a special action
		If StartingIntent.Action = "android.appwidget.action.APPWIDGET_UPDATE_OPTIONS" Then
			Log("ShowStatus: Settings geändert")
			Widget_UpdateSettings
		End If
		'If a widget instance is deleted we can delete its configuration
		If StartingIntent.Action = "android.appwidget.action.APPWIDGET_DELETED" Then
			Log("Widget-Instanz gelöscht")
			Widget_Deleted
		End If
	'Else
	'	Log("ShowStatus: HandleWidgetEvents returned false")
	End If

	'Reschedule the service every minute, so it keeps up to date
	If StartingIntent.Action <> "android.appwidget.action.APPWIDGET_DISABLED" Then
		Dim si As Intent
		si.Initialize("android.appwidget.action.APPWIDGET_UPDATE", "")
		si.SetComponent(GetPackageName & "/.widgetservice")
		StartServiceAt(si, DateTime.Now + DateTime.TicksPerMinute, False)
	End If

End Sub

Sub Service_Destroy
	CancelScheduledService("")
	phone.StopListening
End Sub

Sub Widget_RequestUpdate
	'TickCount = TickCount + 1
	'If IsScreenOn Or TickCount > 10 Then
	If IsScreenOn Then
		'TickCount = 0
		downloadUpdateData
	End If
End Sub

Sub Widget_Disabled
	CancelScheduledService("")
	StopService("")
End Sub

Sub Widget_UpdateSettings
	Widget_RequestUpdate
End Sub

Sub Widget_Deleted
	Dim wid As Int = mAppWidgetIdList.Get(0)
	deleteNotification(wid)
	tSQL.ExecNonQuery2("DELETE FROM widgets WHERE wid = ?", Array As Object(wid))
	Log("Widget deleted: " & wid)
End Sub


Sub downloadUpdateData
	' Anstoßen des Downloads der Daten
	' Da wir möglicherweise mehrere Widgets haben, müssen wir alle durchlaufen
	For i = 0 To mAppWidgetIdList.Size - 1
		Log("ShowStatus: UPD_REQ Widget " & mAppWidgetIdList.Get(i))

		Dim c As Cursor
		c = tSQL.ExecQuery2("SELECT mid FROM widgets WHERE wid = ?", Array As String(mAppWidgetIdList.Get(i)))
		If c.RowCount > 0 Then
			c.Position = 0
			Dim mid As Int
			mid = c.GetInt2(0)
			Dim getJob As HttpJob
			getJob.Initialize("getJob_"&mid, Me)
'			getJob.Download("http://XXXXXXXXXX)
			JobDone(getJob)
			Log("            requested MID " & mid)	
		Else
			Log("            no MID")
		End If
		c.Close
	Next
End Sub


Sub JobDone (Job As HttpJob)
	' Wird von HttpJob aufgerufen, wenn die Antwort auf ein Request da ist
	If Job.Success Then
		rv.SetText("LbStatus", "Bla")
		rv.SetText("LbText", "Blub")
		
		rv.SetVisible("PnRed", False)
		rv.SetVisible("PnYellow", False)
		rv.SetVisible("PnGreen", False)
		rv.SetVisible("PnRed", True)
		'rv.SetVisible("PnYellow", True)
		'rv.SetVisible("PnGreen", True)

		' Rausfinden, welches Widget jetzt beantwortet wurde
		Dim mid As Int = 0

		Dim c As Cursor
		c = tSQL.ExecQuery2("SELECT wid, notif FROM widgets WHERE mid = ?", Array As String(mid))
		For i = 0 To c.RowCount - 1
			c.Position = i
			Dim wid As Int = c.GetInt2(0)
			Log ("            -> updating widget " & wid)
			WidgetEx.UpdateSingleWidget(rv, wid)
			deleteNotification(wid)
			If c.GetInt2(1) > 0 Then
				' Notification anpassen
				createNotification(wid, Null)
			End If
		Next
		c.Close
	Else
		Log("ShowStatus: Download failed: " & Job.ErrorMessage)
	End If
	Job.Release
End Sub


Sub IsScreenOn As Boolean
   Dim r As Reflector
   r.Target = r.GetContext
   r.Target = r.RunMethod2("getSystemService", "power", "java.lang.String")
   Return r.RunMethod("isScreenOn")
End Sub

'Returns the package name of the app
Private Sub GetPackageName As String
    Dim r As Reflector
    Return r.GetStaticField("anywheresoftware.b4a.BA", "packageName")
End Sub

Sub phoneEvent_ScreenOn(i As Intent)
	' Hier sollte er herkommen, wenn das Display eingeschaltet wird
	' Hier muß also auch eine Aktualisierung angestoßen werden
	Log("ShowStatus: PhoneEvent: ScreenOn")

	' Daten holen
	downloadUpdateData
	'TickCount = 0
End Sub



' Notification mit dem Notification Builder
Sub createNotification(nid As Int, statMap As Map)
	Return
	Log("createNotification " & nid)
	nb.SmallIcon = "icon" ' FIXME - Abhänging vom Status!
	nb.Ticker = "Neuer Status" ' FIXME - Status
	nb.DefaultLight = False
	nb.DefaultVibrate = False
	nb.DefaultSound = False		' TODO - vielleicht doch ein Ping?
	nb.ContentTitle = "Sx"
	nb.ContentText = "Name, was?"
	nb.SubText = "Ort"
	nb.UsesChrono = True
	nb.OnGoingEvent = True
	nb.Notify(nid)
	tSQL.ExecNonQuery2("UPDATE widgets SET notifakt = 1 WHERE wid = ?", Array As Object(nid))
End Sub

Sub deleteNotification(nid As Int)
	Return
	Log("deleteNotification " & nid)
	Dim na As String = tSQL.ExecQuerySingleResult("SELECT notifakt FROM widgets WHERE wid = " & nid)
	If na <> Null And na = "1" Then
		nb.Cancel(nid)
		tSQL.ExecNonQuery2("UPDATE widgets SET notifakt = 0 WHERE wid = ?", Array As Object(nid))
	End If
End Sub


' Erzeugen der Datenbank
Sub createDB
	tSQL.ExecNonQuery("CREATE TABLE IF NOT EXISTS widgets (wid INT PRIMARY KEY ON CONFLICT REPLACE, mid INT, notif INT, notifakt INT)")
	Try
		tSQL.ExecQuerySingleResult("SELECT notif FROM widgets")
	Catch
		tSQL.ExecNonQuery("ALTER TABLE widgets ADD notif INT")
	End Try
	Try
		tSQL.ExecQuerySingleResult("SELECT notifakt FROM widgets")
	Catch
		tSQL.ExecNonQuery("ALTER TABLE widgets ADD notifakt INT")
	End Try
End Sub